#ifdef WIN32
#include <windows.h>
#endif

#include <GL/glut.h>

static void drawScene(void)
{
	float white[4]={1,1,1,1};

	glColor3fv(white);  // Used when lighting is disabled
	
	glBegin(GL_POLYGON);
		//glColor3f(1,0,0);			// uncomment to get colored triangle
		glVertex3f( 4.0, 0, 4.0);
		//glColor3f(0,1,0);
		glVertex3f( 4.0, 0,-4.0);
		//glColor3f(0,0,1);
		glVertex3f(-4.0, 0,-4.0);
	glEnd();
}

void display(void)
{
	glClearColor(0.2,0.2,0.8,1.0);						// Set clear color
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); // Clears the color buffer and the z-buffer

	int w = glutGet((GLenum)GLUT_WINDOW_WIDTH);
	int h = glutGet((GLenum)GLUT_WINDOW_HEIGHT);
	glViewport(0, 0, w, h);						// Set viewport
	
	glMatrixMode(GL_PROJECTION);				// Set projection matrix 
	glLoadIdentity();				
	gluPerspective(45.0,w/(float)h, 0.2, 10000.0);		// FOV, aspect ratio, near, far 
	
	glMatrixMode(GL_MODELVIEW);					// Set modelview matrix 
	glLoadIdentity(); 
	
	gluLookAt(10, 10, 10,	// look from
		0, 0, 0,				// look at
		0, 0, 1);				// up vector
		
	
	drawScene();
	glutSwapBuffers();  // swap front and back buffer. This frame will now been displayed.
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	/* open window of size 800x600 with double buffering, RGB colors, and Z-buffering */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(512,512);
	glutCreateWindow("Test App");
	/* the display function is called once when the gluMainLoop is called,
    * but also each time the window has to be redrawn due to window 
    * changes (overlap, resize, etc).  
    */
	glutDisplayFunc(display);	// Set the main redraw function
	
	glutMainLoop();  /* start the program main loop */
	
	return 0;          
}
